Subject: RE: IPv6 Source address selection..

From: Richard Draves <[email-masked]>
Date: Tue, 11 Jul 2000 13:14:44 -0700

A second belated response...

> Just throwing some ideas and questions... the draft
> 
>   draft-ietf-ipngwg-default-addr-select-00.txt
> 
> uses at one stage CommonPrefixLen(SA, D) as a comparison value to
> select between candidate source addresses (prefixes). This is simple
> common bits counted from left ("most significant end"), right?

Yes.
 
> In our code we use following ComparisonValue(SA, D), returns
> 
>   prefixlength, if the common bits covers the prefix,
> and
>   (common bits - prefixlength), when match is less (e.g. this value is
>   always negative)
> 
> This prefers the longest prefix that matches fully. If none matches,
> it prefers the prefix with least differing bits in the "routing
> part".
> 
> "My version" differs only when none of the prefixes match fully. For
> example, if D=xxxyyy... (x = 4bit unit)
> 
> SA= xxxzzzz/32  CommonPrefixLen=12 ComparisonValue= -20
> SB= xxz/12      CommonPrefixlen=8  ComparisonValue= -4
> 
> CommonPrefix would select SA, ComparisonValue would select SB.

If I understand this correctly, it sounds like your implementation maintains
a prefix length associated with each unicast address that is assigned to an
interface. This is why you can speak about SA having a 32 bit prefix length.

This is not universal among IPv6 implementations. There is no specification
that requires or uses such a prefix length. So I don't want to put anything
in the src/dst address selection spec that relies on such a prefix length.

Restricting our attention to implementations that do maintain such a prefix
length associated with unicast addresses, I still don't understand your
motivation. For autoconfigured addresses, wouldn't this prefix length always
be 64? And then if I understand your rule correctly, in most cases it would
prefer exactly the wrong source address - it would prefer the one that has
fewest bits in common with the destination.

Thanks,
Rich
--------------------------------------------------------------------
IETF IPng Working Group Mailing List
IPng Home Page:                      http://playground.sun.com/ipng
FTP archive:                      ftp://playground.sun.com/pub/ipng
Direct all administrative requests to [email-masked]
--------------------------------------------------------------------